#!/bin/bash

LOVELIST="/glftpd/tmp/love.list" # Full path. Not chrooted.
DATAPATH="/glftpd/ftp-data" # Full path. Not chrooted.
LOGFILE="/glftpd/ftp-data/logs/glftpd.log" #relative to rootpath
VERBOSE="1"
bonus="1000000"

chmod 777 $DATAPATH/users/*

[ -f "$LOVELIST" ] || {
    echo "Error: Rape list file '$LOVELIST' nonexistent." 1>&2
    exit 1
}

[ -d "$DATAPATH" ] || {
    echo "Error: Invalid DATAPATH '$DATAPATH'." 1>&2
    exit 1
}

cut -f2 -d: "$LOVELIST" | sort | uniq -c | sort -rn | {
    read count user || exit
    [ -f "$DATAPATH/users/$user" ] || {
        [ "$VERBOSE" = "1" ] && 
            echo "User with most love, '$user' does not seem to exist." 1>&2
        exit 1
    }
    [ -w "$DATAPATH/users" ] || {
        [ "$VERBOSE" = "1" ] && 
            echo "Error: $DATAPATH/users is not writable!" 1>&2
        exit 1
    }

     mv -f "$DATAPATH/users/$user" "$DATAPATH/users/backup/$user.old"
     curcreds="$(cat $DATAPATH/users/backup/$user.old | grep CREDITS | awk -F" " '{print $2}')"
     aftercreds="$(expr $curcreds + $bonus)"

     sed -e "8,8 s/$curcreds/$aftercreds/" $DATAPATH/users/backup/$user.old > $DATAPATH/users/$user    

    echo "$(date +'%a %b %d %T %Y') LOVEHATE: Most loved user this week was $user. 1Gb creds given!" >> "$LOGFILE"
    echo "Gave $bonus creds to '$user' for being so loved."
}

> "$LOVELIST"

exit 0
