#!/bin/bash

LOVELIST="/tmp/love.list" #relative to rootpath
DATAPATH="/ftp-data" #relative to rootpath
LOGFILE="/ftp-data/logs/glftpd.log" #relative to rootpath

>> "$LOVELIST" 2>/dev/null

[ -z "$1" ] && {
    echo "Usage: SITE LOVE username"
    echo ""
    echo "-=[ CURRENT STANDINGS ]=-"
    echo ""
    echo -e "  Loves\tUser"
    echo -e "  -----\t----"
    grep ":" "$LOVELIST" | cut -f2 -d: | sort | uniq -c
    exit 0
}

[ -w "$LOVELIST" ] || {
    echo "Error: $LOVELIST not writable."
    exit 2
}

[ -f "$DATAPATH/users/$1" ] || {
    echo "User '$1' doesn't exist."
    exit 2
}

[ "$USER" = "$1" ] && {
    echo "You can't love yourself THAT much!"
    echo "$(date +'%a %b %d %T %Y') LOVEHATE: $1 tries to make love to himself, but hes not that agile!" >> "$LOGFILE"
    exit 1
}

grep "^$USER:" "$LOVELIST" | {
    IFS=":" read this that && {
        echo "You have already chosen to love '$that' this week. You dont wanna get sore now, do ya?"
        exit 1
    }
    exit 0
} || exit 1

echo "$USER:$1" >> "$LOVELIST"

loves=$(($(grep ":$1$" "$LOVELIST" | wc -l)))

[ -w "$LOGFILE" ] && {
    echo "$(date +'%a %b %d %T %Y') LOVEHATE: $USER thinks $1 is great! $1 has been loved $loves times!" >> "$LOGFILE"
}

exit 0
